/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: DisplayableAsSupport.java,v 522113f249b1 2010/06/07 18:38:05 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.observation.simple;

import it.tidalwave.util.Displayable;
import java.util.Locale;
import java.util.Map;
import java.util.SortedSet;
import javax.annotation.Nonnull;

/***********************************************************************************************************************
 *
 * Temporary for supporting implements Displayable on a number of classes
 * 
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class DisplayableAsSupport extends AsSupport implements Displayable
  {
    public DisplayableAsSupport (final @Nonnull Object ... capabilities)
      {
        super(capabilities);
      }

    public String getDisplayName()   
      {
        return as(Displayable.class).getDisplayName();
      }

    public String getDisplayName(Locale locale)
      {
        return as(Displayable.class).getDisplayName(locale);
      }

    public Map<Locale, String> getDisplayNames()
      {
        return as(Displayable.class).getDisplayNames();
      }

    public SortedSet<Locale> getLocales()
      {
        return as(Displayable.class).getLocales();
      }
  }
