/***********************************************************************************************************************
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 **********************************************************************************************************************/
package it.tidalwave.semantic;

import javax.annotation.CheckForNull;
import javax.annotation.Nonnull;
import it.tidalwave.util.Id;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public final class Property<T> implements Comparable<Property<T>>
  {
    @Nonnull
    private final Id id;

    @Nonnull
    private final T value;

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public Property (final @Nonnull String id, final @Nonnull T value)
      {
        this(new Id(id), value);
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public Property (final @Nonnull Id id, final @Nonnull T value)
      {
        this.id = id;
        this.value = value;
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Nonnull
    public Id getId()
      {
        return id;
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Nonnull
    public T getValue()
      {
        return value;
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Override
    public int compareTo (final @Nonnull Property<T> other)
      {
        return this.id.compareTo(other.id);
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Override
    public boolean equals (final @CheckForNull Object other)
      {
        return (other != null)
               && (other instanceof Property)
               && this.id.equals(((Property)other).id)
               && this.value.equals(((Property)other).value);
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Override
    public int hashCode()
      {
        return id.hashCode() * 39 + value.hashCode();
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Override @Nonnull
    public String toString()
      {
        return String.format("Property[%s=%s]", id, value);
      }
  }
